<?php
class TabberTabController extends RController
{
    /**
     * @return array action filters
     */
    public function filters() {
        return array(
            'rights',
            'postOnly + delete', // we only allow deletion via POST request
        );
    }
    /**
     * Displays a particular model.
     * @param integer $id the ID of the model to be displayed
     */
    public function actionView($id)
    {
	$this->render('view', array(
	    'model' => $this->loadModel($id),
	));
    }
    /**
     * Creates a new model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     */
    public function actionCreate($tabber_id)
    {
	$model = new TabberTab;
	$model->tabber_id = $tabber_id;
	// Uncomment the following line if AJAX validation is needed
	// $this->performAjaxValidation($model);
	if (isset($_POST['TabberTab']))
	{
	    $model->attributes = $_POST['TabberTab'];
	    if ($model->save())
		$this->redirect(array('tabber/view', 'id' => $tabber_id));
	}
	$this->render('create', array(
	    'model' => $model,
	));
    }
    /**
     * Updates a particular model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id the ID of the model to be updated
     */
    public function actionUpdate($id)
    {
	$model = $this->loadModel($id);
	$tabber_id = $model->tabber_id;
	// Uncomment the following line if AJAX validation is needed
	// $this->performAjaxValidation($model);
	if (isset($_POST['TabberTab']))
	{
	    $model->attributes = $_POST['TabberTab'];
	    if ($model->save())
		$this->redirect(array('tabber/view', 'id' => $tabber_id));
	}
	$this->render('update', array(
	    'model' => $model,
	));
    }
    /**
     * Deletes a particular model.
     * If deletion is successful, the browser will be redirected to the 'admin' page.
     * @param integer $id the ID of the model to be deleted
     */
    public function actionDelete($id)
    {
	$model = $this->loadModel($id);
	$tabber_id = $model->tabber_id;
	$model->delete();
	// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
	if (!isset($_GET['ajax']))
	    $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('tabber/view', 'id' => $tabber_id));
    }
    /**
     * Manages all models.
     */
    public function actionAdmin($tabber_id)
    {
	$model = new TabberTab('search');
	$model->unsetAttributes();  // clear any default values
	if (isset($_GET['TabberTab']))
	    $model->attributes = $_GET['TabberTab'];
	$model->tabber_id = $tabber_id;
	$this->render('admin', array(
	    'model' => $model,
	));
    }
    /**
     * Returns the data model based on the primary key given in the GET variable.
     * If the data model is not found, an HTTP exception will be raised.
     * @param integer $id the ID of the model to be loaded
     * @return TabberTab the loaded model
     * @throws CHttpException
     */
    public function loadModel($id)
    {
	$model = TabberTab::model()->findByPk($id);
	if ($model === null)
	    throw new CHttpException(404, 'The requested page does not exist.');
	return $model;
    }
    /**
     * Performs the AJAX validation.
     * @param TabberTab $model the model to be validated
     */
    protected function performAjaxValidation($model)
    {
	if (isset($_POST['ajax']) && $_POST['ajax'] === 'tabber-tab-form')
	{
	    echo CActiveForm::validate($model);
	    Yii::app()->end();
	}
    }
}
